/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package soutez;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jsoup.Jsoup;

/**
 *
 * @author soutez201
 */
public class Control {
    String url; 
    String id; 
    double targetRatio; // Vx/Vy that will lead to safe landing
    double currentRatio; // Vx/Vy now
    double vx;
    double vy;
    int direction; //-1 - left (<-); 1 - right (->)
    double x;
    double y;
    double startY;//initial y coordinate
    double fuel;//=P
    double targetStart; //=L
    double targetEnd;  //=R
    double speedLim;
    public Control(String url, double speedLim) throws IOException{
        String _startParams = Jsoup.connect(url+"/start")//connect to server
        .execute()//commence request
        .body();//get reply as string
        assingValues(_startParams, true);
        this.url=url;
        this.speedLim=speedLim;
    }
    private double tn(String s){//toNum
        return Double.valueOf(s);
    }
    private void assingValues(String reply, boolean start){//uses reply from server to assing parameters
        String [] vals = reply.split("\\s+");//split by whitespaces
        id=vals[0];
        x=tn(vals[1]);
        y=tn(vals[2]);
        if(start)
            startY=y;
        vx=tn(vals[3]);
        vy=tn(vals[4]);
        
        fuel=tn(vals[5]);
        targetStart=tn(vals[6]);
        targetEnd=tn(vals[7]);
    }

    /**
     * send new instructions to shuttle
     * @return state of landing(0-in progress 1-succes -1-fail)
     * @throws java.io.IOException
     */
    public int step() throws IOException{
        String reply="";
        double centerLanding=(targetStart+targetEnd)/2d;//center of the landing pad
        if(targetEnd-centerLanding-10.5>Math.abs(x-centerLanding)){//is adirectly above landing pad?
            reply=vertStep(true, 0, 0);
        }else {
            reply=vertStep(false, x-centerLanding>0?1:-1, Math.abs(x-centerLanding)-(targetEnd-centerLanding-10.5));
            //System.err.println(reply);
        }
        if(reply.contains("Zdar!")){
            return 1;
        }else if(reply.contains("Krach")){
            return -1;
        }else{
            assingValues(reply, false);
            return 0;
        }
    }
    //for vertical landings(shuttle above landing zone(returns response from server

    /**
     *
     * @param isVert whether shuttle should fall straight down
     * @param direction -1-left 1-right(irrelevant if isVert==false) 
     * @param targetX distance to target x coordinate (irrelevant if isVert==false)
     * @return response from server
     * @throws IOException
     */
    private String vertStep(boolean isVert, int direction, double targetX) throws IOException{
        Integer [] motors=new Integer[3]; //{levo,nahoru,pravo}
        //left, right handle
        for (int i = 0; i < 3; i++)motors[i]=0;
        if(isVert){
            if(Math.abs(vx)<0.2){//straight down
                motors[0]=0;
                motors[2]=0;
            }else if(vx<0){//to the left
                motors[2]=1;
                motors[0]=0;
            }else{    //to the right
                motors[2]=0;
                motors[0]=1;
            }
        }else{
            if(direction<0&&vx<20){
                motors[2]=1;
                motors[0]=0;
            }else if (direction<0){
                motors[2]=0;
                motors[0]=0;
            }
            if(direction>0&&vx<20){
                motors[2]=0;
                motors[0]=1;
            }else if(direction>0)
                motors[2]=0;
                motors[0]=0;            
        }
        //up handle
        if((vy*vy-19)>y-10){ //prevent failing due to too fast(start slowing down as late as possible(actually 1jm sooner for safety reasons))
            motors[1]=1;
        }else{
            motors[1]=0;
        }
        
        //limits
        
        if(vx>speedLim-1){
            motors[0]=0;
        }
        else if(-vx>speedLim-1){
            motors[2]=0;
        }
        if(-vy>speedLim-1){//vy will never be positive unless it starts out as so
            motors [1]=1;
        }
        
        return Jsoup.connect(url+"/stav?id="+id+"&nahoru="+motors[1].toString()+"&doleva="+motors[0].toString()+"&doprava="+motors[2].toString())//connect to server
        .execute()//commence request
        .body();//get reply as string
    }
}
